#==============================================================================
# ★RGSS2 
# STR11+atb_後付ATBカウントゲージ v1.0 08/03/20
# ◇必須スクリプト STR11e_バトルステータス++ 
# 　　　　　　　　 STR33g1_バトルステータス+ のどちらか
#
# ・パーティステータスにSTR33_ATB専用のカウントゲージを加えます。
#　
#==============================================================================
# ■ Window_BattleStatus
#==============================================================================
class Window_BattleStatus < Window_Selectable
  # スキンファイル名
  BTSKIN_17 = "wait_gauge01"   # ゲージファイル名
  BTSKIN_18 = "wait_gauge00"   # スキンファイル名
  # XP風バトル設定
  BTSKIN_17XY = [  0,  -8]     # ゲージ座標 [x, y]
  BTSKIN_18XY = [ -8, -16]     # スキン座標 [x, y]
  # 通常設定
  # ↓コメントアウト
  #BTSKIN_17XY = [300,  16]     # ゲージ座標 [x, y]
  #BTSKIN_18XY = [292,   8]     # スキン座標 [x, y]
  #--------------------------------------------------------------------------
  # ★ エイリアス
  #--------------------------------------------------------------------------
  alias initialize_str11pog initialize
  def initialize(f = false)
    @wagw = (Cache.system(BTSKIN_17)).width
    initialize_str11pog(f)
  end
  #--------------------------------------------------------------------------
  # ● アイテム作成
  #--------------------------------------------------------------------------
  alias draw_item_str11pwa draw_item
  def draw_item(index)
    return unless @f
    actor = $game_party.members[index]
    draw_item_str11pwa(index)
    s = @s_sprite[index]
    # ウェイトゲージ
    s[17] = Sprite.new(@viewport)
    s[17].bitmap = Cache.system(BTSKIN_17)
    s[17].x = @x[index] + BTSKIN_B_XY[0] + BTSKIN_17XY[0]
    s[17].y = @y[index] + BTSKIN_B_XY[1] + BTSKIN_17XY[1]
    s[17].z = 4
    w = s[17].bitmap.width
    h = s[17].bitmap.height / 3
    s[17].src_rect.set(0, 0, w, h)
    # ウェイトスキン
    s[18] = Sprite.new(@viewport)
    s[18].bitmap = Cache.system(BTSKIN_18)
    s[18].x = @x[index] + BTSKIN_B_XY[0] + BTSKIN_18XY[0]
    s[18].y = @y[index] + BTSKIN_B_XY[1] + BTSKIN_18XY[1]
    s[18].z = 3
    #
    s[20] = ((@wagw * (actor.ctb_gauge / (actor.max_ctb_gauge * 1.0))) + 1).truncate
    s[17].src_rect.width = s[20]
    # 不可視に
    for l in [17,18]
      s[l].opacity = 0
    end
    # 追加判定
    @s_party[10] = actor.ctb_gauge
  end
  #--------------------------------------------------------------------------
  # ● オブジェクト開放
  #--------------------------------------------------------------------------
  alias dispose_str11pwa dispose
  def dispose
    dispose_str11pwa
    for i in 0...@s_sprite.size
      for l in [17,18]
        @s_sprite[i][l].bitmap.dispose
        @s_sprite[i][l].dispose
      end
    end
  end
  #--------------------------------------------------------------------------
  # ● フレーム更新
  #--------------------------------------------------------------------------
  alias update_str11pwa update
  def update
    update_str11pwa
    return unless @f
    for i in 0...@s_sprite.size
      s = @s_sprite[i]
      # 不透明度アップ
      if @opacity < 272
        for l in [17,18]
          s[l].opacity = @opacity
        end
      end
      # ウェイトゲージ更新
      update_wa(s,$game_party.members[i],@s_party[i])
    end
  end
  #--------------------------------------------------------------------------
  # ● フレーム更新 (ウェイトゲージ)
  #--------------------------------------------------------------------------
  def update_wa(s,a,m)
    sr = s[17].src_rect
    # 色変更
    gauge = a.ctb_gauge
    if a.aw_gauge > 0
      gauge = a.aw_gauge
      s[17].src_rect.y = s[17].src_rect.height * 2
    elsif @wagw <= sr.width
      s[17].src_rect.y = s[17].src_rect.height
    else
      s[17].src_rect.y = 0
    end
    # ゲージ更新
    if gauge != m[10]
      s[20] = ((@wagw * (gauge / (a.max_ctb_gauge * 1.0))) + 1).truncate
      m[10] = (gauge)
      s[17].src_rect.width = s[20]
    end
  end
end