#==============================================================================
# ★RGSS2 
# STR11xatb_ATB併用スクリプト v1.0 08/04/16
#
# ・STR11_XP風バトルとSTR33_アクティブタイムバトルを
# 　併用するためのスクリプトです。
# ・導入順はATBサンプルプロジェクトのスクリプトエディタに記述されている
# 　"スクリプト組み合わせ例"をご覧ください。
#
#==============================================================================
# ■ Window_TargetEnemy
#==============================================================================
class Window_TargetEnemy < Window_Command
  #--------------------------------------------------------------------------
  # ● オブジェクト初期化(エイリアス)
  #--------------------------------------------------------------------------
  alias initialize_str11x33 initialize
  def initialize
    initialize_str11x33
    @e_exist = []
    for enemy in $game_troop.members
      @e_exist[enemy.index] = enemy.exist?
    end
  end
  #--------------------------------------------------------------------------
  # ● フレーム更新(再定義)
  #--------------------------------------------------------------------------
  def update
    super
    for enemy in $game_troop.members
      if @e_exist[enemy.index] != enemy.exist?
        # エネミーリスト変動
        commands = []
        @enemies = []
        for enemy in $game_troop.members
          next unless enemy.exist?
          commands.push(enemy.name)
          @enemies.push(enemy)
        end
        initialize_2(416, commands, 8, 1)
        self.z = -100
        self.back_opacity = 0
        self.opacity = 0
        self.contents_opacity = 0
        @e_exist = []
        for enemy in $game_troop.members
          @e_exist[enemy.index] = enemy.exist?
        end
      end
    end
  end
end
#==============================================================================
# ■ Scene_Battle
#==============================================================================
class Scene_Battle < Scene_Base
  #--------------------------------------------------------------------------
  # ● ウィンドウ開放(追加)
  #--------------------------------------------------------------------------
  alias dispose_windows_str11x33 dispose_windows
  def dispose_windows
    dispose_windows_str11x33
    @cursor.type = -1
    @cursor.xx = 544 / 2
    @cursor.yy = 416 / 2
    @cursor.visible = false
    update_strbtflash
  end
  #--------------------------------------------------------------------------
  # ★ 再定義
  #--------------------------------------------------------------------------
  alias update_basic_str11x33 update_basic
  def update_basic(m = false)
    update_basic_str11x33(m)
    update_xpstbt_cursor unless m
  end
  #--------------------------------------------------------------------------
  # ● 個別オートバトル処理(再定義)
  #--------------------------------------------------------------------------
  def actor_autobattle
    Sound.play_decision
    if @a_command_battler != nil
      @a_command_battler.ctb_actionstart = true
      @a_command_battler.make_action
      @a_command_battler.ctb_actionstart = false
    end
    update_strbtflash
    next_actor
  end
end


