#==============================================================================
# ★RGSS2 
# STR29_スピーディバトルATB v0.8 08/04/16
#
# ・アクティブタイムバトル向けのバトルウェイト調整スクリプト。
# ・ボタンによる早送りを無効にして、バトルスピードの一定化を図ります。
# ※他のスピーディバトルとは併用しないでください。
#
#==============================================================================
# ■ STRRGSS2(設定箇所)
#==============================================================================
module STRRGSS2 ;module STR29
  WAIT    = 4     # ウェイト修正
  ANSKIP  = 6     # アニメーションスキップ
  STR11F  = true  # バトルメッセージ封印と併用
  # 以下の設定は STR11F の値をtrueにした場合のみ有効です。
  STR18DM = 8     # 行動後ウェイト
end; end
#==============================================================================
# ■ Sprite_Battler
#==============================================================================
class Sprite_Battler < Sprite_Base
  #--------------------------------------------------------------------------
  # ★ 再定義
  #--------------------------------------------------------------------------
  def animation?
    return @animation_duration > STRRGSS2::STR29::ANSKIP
  end
  #--------------------------------------------------------------------------
  # ★ エイリアス
  #--------------------------------------------------------------------------
  alias update_str29 update
  def update
    update_str29
    self.visible = true if @effect_type != BLINK # 点滅バグ防止
  end
end
#==============================================================================
# ■ Scene_Battle
#==============================================================================
class Scene_Battle < Scene_Base
  #--------------------------------------------------------------------------
  # ● 一定時間ウェイト
  #--------------------------------------------------------------------------
  def wait(duration, no_fast = false)
    duration /= STRRGSS2::STR29::WAIT
    for i in 0...(duration)
      update_basic
    end
  end
  #
  if STRRGSS2::STR29::STR11F
  #--------------------------------------------------------------------------
  # ★ 一定時間ウェイト:再定義
  #--------------------------------------------------------------------------
  def wait(duration, no_fast = false, w = 1)
    while w > 0
      update_basic
      w -= 1
    end
  end
  #--------------------------------------------------------------------------
  # ● 行動結果の表示
  #--------------------------------------------------------------------------
  alias display_action_effects_str18 display_action_effects
  def display_action_effects(target, obj = nil)
    display_action_effects_str18(target, obj)
    wait(0, false, STRRGSS2::STR29::STR18DM)
  end;end
end