#==============================================================================
# ★RGSS2 
# STR33g3_逃走ゲージ付加 v0.9 08/03/27
# 
# ・ATBの押しっぱなし逃走のゲージプラグイン。
#
#==============================================================================
# ■ Spriteset_Battle
#==============================================================================
class Spriteset_Battle
  # ゲージバックの色　[枠の色, 枠中の色]
  ESCGAUGE_BC   = [Color.new(0,0,0), Color.new(32,48,64)]
  # ゲージのグラデーション色　[左, 右]
  ESCGAUGE_GC   = [Color.new(64,174,108), Color.new(160,255,236)]
  # 
  ESCGAUGE_XY   = [348,60]        # 座標
  ESCGAUGE_W    = 192             # ゲージ幅
  ESCGAUGE_H    = 6               # ゲージ高さ
  #
  ESCTEXT_SIZE  = 16              # テキストサイズ
  ESCTEXT       = "ＥＳＣＡＰＥ"  # ゲージ左上に表示する文字列
  ESCTEXT_POS   = 1               # テキスト上下位置(0:ゲージ上 1:ゲージ下)
  ESCTEXT_ALIGN = 2               # 文字揃え(0:左揃え 1:中央揃え 2:右揃え)
  #--------------------------------------------------------------------------
  # ● ゲージ作成(追加)
  #--------------------------------------------------------------------------
  def create_escape_gauge
    # インスタンス
    @esc_opacity = 0
    @esc_count = $game_troop.escape_count
    #
    b = ESCGAUGE_BC # バックカラー
    c = ESCGAUGE_GC # ゲージカラー
    # ゲージ下地
    bitmap_1 = Bitmap.new(ESCGAUGE_W, ESCGAUGE_H + ESCTEXT_SIZE)
    if ESCTEXT_POS == 0
      bitmap_1.fill_rect(0, 0+ESCTEXT_SIZE, ESCGAUGE_W, ESCGAUGE_H, b[0]) 
      bitmap_1.fill_rect(1, 1+ESCTEXT_SIZE, ESCGAUGE_W - 2, ESCGAUGE_H - 2, b[1]) 
      str = ESCTEXT; align = ESCTEXT_ALIGN
      bitmap_1.font.size = ESCTEXT_SIZE
      bitmap_1.draw_text(0, 0, ESCGAUGE_W, ESCTEXT_SIZE, str, align)
    else
      bitmap_1.fill_rect(0, 0, ESCGAUGE_W, ESCGAUGE_H, b[0]) 
      bitmap_1.fill_rect(1, 1, ESCGAUGE_W - 2, ESCGAUGE_H - 2, b[1]) 
      str = ESCTEXT; align = ESCTEXT_ALIGN
      bitmap_1.font.size = ESCTEXT_SIZE
      bitmap_1.draw_text(0, ESCGAUGE_H, ESCGAUGE_W, ESCTEXT_SIZE, str, align)
    end
    # ゲージ
    bitmap_2 = Bitmap.new(ESCGAUGE_W, ESCGAUGE_H)
    bitmap_2.gradient_fill_rect(1, 1,
                                ESCGAUGE_W - 2, ESCGAUGE_H - 2, c[0], c[1]) 
    # スプライト作成
    @gauge_back = Sprite.new(@viewport2)
    @gauge_back.bitmap = bitmap_1
    @gauge_back.x = ESCGAUGE_XY[0]; @gauge_back.y = ESCGAUGE_XY[1]
    @gauge_back.opacity = @esc_opacity
    #
    @gauge = Sprite.new(@viewport2)
    @gauge.bitmap = bitmap_2
    @gauge.x = ESCGAUGE_XY[0]; @gauge.y = ESCGAUGE_XY[1]
    @gauge.y += ESCTEXT_SIZE if ESCTEXT_POS == 0
    @gauge.opacity = @esc_opacity
    @gauge.src_rect.width = escgauge_width
  end
  #--------------------------------------------------------------------------
  # ● 解放(追加)
  #--------------------------------------------------------------------------
  def dispose_escape_gauge
    for i in [@gauge_back, @gauge]
      i.bitmap.dispose
      i.dispose
    end
  end
  #--------------------------------------------------------------------------
  # ● ゲージ横幅取得(追加)
  #--------------------------------------------------------------------------
  def escgauge_width
    count = $game_troop.escape_count; max = $game_troop.max_escape_count
    max += 1
    return ((ESCGAUGE_W * (count / (max * 1.0))) + 1).truncate
  end
  #--------------------------------------------------------------------------
  # ● ゲージ更新(追加)
  #--------------------------------------------------------------------------
  def update_escape_gauge
    if @esc_count != $game_troop.escape_count
      if @esc_count < $game_troop.escape_count
        @esc_opacity = [[384, @esc_opacity + 16].min, 0].max
      end
      @gauge.src_rect.width = escgauge_width
      @esc_count = $game_troop.escape_count
    else
      @esc_opacity = [[384, @esc_opacity - 4].min, 0].max
    end
    for i in [@gauge_back, @gauge]
      i.opacity = @esc_opacity
    end
  end
  #--------------------------------------------------------------------------
  # ● オブジェクト初期化(エイリアス)
  #--------------------------------------------------------------------------
  alias create_viewports_str33g1 create_viewports
  def create_viewports
    create_viewports_str33g1
    create_escape_gauge
  end
  #--------------------------------------------------------------------------
  # ● 解放(エイリアス)
  #--------------------------------------------------------------------------
  alias dispose_str33g1 dispose
  def dispose
    dispose_escape_gauge
    dispose_str33g1
  end
  #--------------------------------------------------------------------------
  # ● フレーム更新(エイリアス)
  #--------------------------------------------------------------------------
  alias update_str33g1 update
  def update
    update_escape_gauge
    update_str33g1
  end
end
